#include <stdio.h>
#include <stdlib.h>

struct punto2D {
	int x, y;
};

typedef struct punto2D PUNTO2D;

struct nodopunto2d {
	int x, y;
	struct nodopunto2d * psig;
};

typedef struct nodopunto2d NODOPUNTO2D;

typedef NODOPUNTO2D* LISTAPUNTO2D;

/**
NODOPUNTO2D * crea_elemento( );
void inserta_elemento( NODOPUNTO2D **L, NODOPUNTO2D *nodo );
void insertaDespues( NODOPUNTO2D *paqui, NODOPUNTO2D *pnodo );
void insertaAntes( NODOPUNTO2D **pL, NODOPUNTO2D *paqui, NODOPUNTO2D *pnodo );
NODOPUNTO2D * obtiene_elemento( NODOPUNTO2D *L, NODOPUNTO2D *pnodo );
void actualiza_elemento( NODOPUNTO2D *L, NODOPUNTO2D *pbusca, NODOPUNTO2D *pnodo )
void borra_lista( NODOPUNTO2D **pL );
void imprime_lista( NODOPUNTO2D *L );
int calcula_largo( NODOPUNTO2D *L );
**/

NODOPUNTO2D * crea_elemento( )
{
	NODOPUNTO2D *p;

	p = (NODOPUNTO2D *)malloc( sizeof(NODOPUNTO2D) );
	if( p == NULL )
		return NULL;

	p->psig = NULL; // Muy importante!!!

	return p;
}

void inserta_elemento(LISTAPUNTO2D * L, NODOPUNTO2D * nodo)
{
	if( *L == NULL ) {
		*L = nodo;
	}
	else{ //push_front
		nodo->psig = *L;
		*L = nodo;
	}
}

/**
 paqui es una copia del puntero al nodo donde se insertarÃ¡
 pnode es un puntero al dato que se insertarÃ¡
**/
void insertaDespues( NODOPUNTO2D *paqui, NODOPUNTO2D *pnodo )
{
	if ( paqui != NULL ) {
		if( paqui->psig == NULL ) {
			paqui->psig = pnodo;
		}
		else {
			pnodo->psig = paqui->psig;
			paqui->psig = pnodo;
		}
	}
}

/**
 pL un puntero a la lista, porque se puede modicar el
  inicio de ella
 paqui es una copia del puntero al nodo donde se insertarÃ¡
 pnode es un puntero al dato que se insertarÃ¡
**/
void insertaAntes( LISTAPUNTO2D *pL, NODOPUNTO2D *paqui, NODOPUNTO2D *pnodo )
{
	NODOPUNTO2D *pantes;

	if ( paqui != NULL ){
		if( *pL == paqui ) {
			pnodo -> psig = *pL;
			*pL = pnodo;
		}
		else {
			pantes = *pL;
			while( pantes->psig != paqui && pantes->psig != NULL )
				pantes = pantes -> psig;

			pnodo->psig = paqui;
			pantes->psig = pnodo;
		}
	}
}

/**
  Busca el elemento apuntado por pnodo en la lista.
  Como no modifica el inicio de la lista, pasamos una
copia en L
**/
NODOPUNTO2D * obtiene_elemento( NODOPUNTO2D *L, NODOPUNTO2D *pnodo )
{
	while( L->psig != NULL ) {
		if( L->x == pnodo->x &&
		    L->y == pnodo->y )
			return( L );
		L = L->psig;
	}
	return NULL;
}

int calcula_largo( NODOPUNTO2D *p )
{
	int n=0;

	while( p != NULL ){
		n++;
		p = p->psig;
	}

	return n;
}

void actualiza_elemento( LISTAPUNTO2D L, NODOPUNTO2D *pbusca, NODOPUNTO2D *pnodo )
{
	NODOPUNTO2D *p;

	p = obtiene_elemento( L, pbusca );
	if ( p != NULL ) {
		p->x = pnodo->x; 
		p->y = pnodo->y; 
	}
}

/** Se le puede pasar una copia de la lista
  porque no modificamos la lista al imprimir
**/
void imprime_lista( LISTAPUNTO2D p )
{
	while( p != NULL ) {
		printf("%d %d\n", p->x, p->y );
		p = p->psig;
	}
}

void borra_lista( LISTAPUNTO2D *pL )
{
	NODOPUNTO2D *p;

	p = *pL;
	while( p != NULL ) {
		// Error: *pL = *pL->psig;
		*pL = (*pL)->psig;
		free( p );
		p = *pL;
	}
} 

PUNTO2D * list_to_array(LISTAPUNTO2D it, int n) {
	PUNTO2D * array = (PUNTO2D *)malloc(n*sizeof(PUNTO2D));
	int i = 0;
	while( it != NULL ) {
		array[i].x = it->x;
		array[i].y = it->y;
		it = it->psig;
		i++;
	}
	return array;
}

void array_to_list(PUNTO2D * array, LISTAPUNTO2D * L, int n){
	for (int i = 0; i < n; i++, *L = (*L)->psig) {
		(*L)->x = array[i].x;
		(*L)->y = array[i].y;
	}
}